import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.MouseInputAdapter;
import java.awt.Color;
import java.awt.geom.*;


import javax.swing.text.*;

public class UpdateFrame extends JFrame
{
fecha date;
fecha alarmDate;
JTextArea textArea;
JScrollPane scrollPane;
AgendaFrame calendario;
MemoryHandler memory;
JRadioButton cadaMes;
JRadioButton cadaAno;
JRadioButton esteDia;
int locationX = 400;
int locationY = 400;
Insets insets;
JLabel label;
JPanel buttonPanel;
JPanel colorPanel;
JButton campanaButton;
JButton noCampanaButton;
JButton blueButton;
JButton greenButton;
JButton redButton;
JButton blackButton;
JButton yellowButton;
Color color = Color.black;
Color red = new Color(204,0,0);
Color yellow = new Color(255, 255, 153);
Color green = new Color(0, 153, 102);
Color blue = new Color(0, 51, 153);
ChooseFrame choose;
int mes;
int ano;


public UpdateFrame (fecha d, AgendaFrame cal, MemoryHandler m)
{
date = d;
mes = Integer.valueOf(date.getMonth());
ano = Integer.valueOf(date.getYear());
calendario = cal;
memory = m;
Container contentPane = getContentPane();
contentPane.setBackground(Color.white);
insets = contentPane.getInsets(); 
contentPane.setLayout(null);
setLocation (locationX, locationY);
textArea = new JTextArea();
textArea.setEditable(true);
textArea.setForeground(new Color(204,0,0));
textArea.setBackground (new Color(255, 255, 153));

esteDia = new JRadioButton("solo este dia");
esteDia.setActionCommand("dia");
esteDia.setBackground(Color.white);
esteDia.addActionListener(new ButtonListener());
cadaMes = new JRadioButton("evento que vuelve cada mes");
cadaMes.setActionCommand("mes");
cadaMes.setBackground(Color.white);
cadaMes.addActionListener(new ButtonListener());
cadaAno = new JRadioButton("evento que vuelve cada ano");
cadaAno.setActionCommand("ano");
cadaAno.setBackground(Color.white);
cadaAno.addActionListener(new ButtonListener());
ButtonGroup buttonGroup = new ButtonGroup();
buttonGroup.add(esteDia);
buttonGroup.add(cadaMes);
buttonGroup.add(cadaAno);
campanaButton = new JButton(new ImageIcon("Image/campana.jpg"));
campanaButton.addActionListener(new ColorPanelListener());
campanaButton.setBackground(Color.white);
campanaButton.setActionCommand("setAlarm");

noCampanaButton = new JButton(new ImageIcon("Image/noCampana.jpg"));
noCampanaButton.addActionListener(new ColorPanelListener());
noCampanaButton.setBackground(Color.white);
noCampanaButton.setActionCommand("deleteAlarm");

blueButton = new JButton();
blueButton.setBackground(blue);
blueButton.setActionCommand("blue");
blueButton.addActionListener(new ColorPanelListener());
redButton = new JButton();
redButton.setBackground(red);
redButton.setActionCommand("red");
redButton.addActionListener(new ColorPanelListener());
greenButton = new JButton();
greenButton.setBackground(green);
greenButton.setActionCommand("green");
greenButton.addActionListener(new ColorPanelListener());
yellowButton = new JButton();
yellowButton.setBackground(yellow);
yellowButton.setActionCommand("yellow");
yellowButton.addActionListener(new ColorPanelListener());
blackButton = new JButton();
blackButton.setBackground(Color.black);
blackButton.setActionCommand("black");
blackButton.addActionListener(new ColorPanelListener());


Event evento = memory.getEvent(date);

if (evento.state())
   {
	if (evento.getDayEvent() != null) 
	   {
		 textArea.setText(evento.getDayEvent());
		 esteDia.setSelected(true);
		 alarmDate = evento.getDayAlarm();
		 }
		 
	if (evento.getMonthEvent() != null)
	   {
		 textArea.setText(evento.getMonthEvent());
		 cadaMes.setSelected(true);
		 alarmDate = evento.getMonthAlarm();
		}
	if (evento.getYearEvent() != null)
	   {
		 textArea.setText(evento.getYearEvent());
		 cadaAno.setSelected(true);
		 alarmDate = evento.getYearAlarm();
		}
	}
else esteDia.setSelected(true);

if (evento.getColor() != null) 
   {
	 if (blue.equals(evento.getColor())) color = blue;
	 if (red.equals(evento.getColor())) color = red;
	 if (green.equals(evento.getColor())) color = green;
	 if (yellow.equals(evento.getColor())) color = yellow;
	}


label =new JLabel (date.toString());
MouseMotionHandler listener = new MouseMotionHandler();
label.addMouseListener (listener);
label.addMouseMotionListener(listener);
label.setForeground(new Color(204,0,0));
label.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));

label.setHorizontalAlignment(JLabel.CENTER);
label.setVerticalAlignment(JLabel.CENTER);
scrollPane = new JScrollPane(textArea);
scrollPane.setVerticalScrollBarPolicy(
JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
Style def = StyleContext.getDefaultStyleContext().
            getStyle(StyleContext.DEFAULT_STYLE);
scrollPane.getViewport().setOpaque(false);

buttonPanel = new JPanel();
buttonPanel.setBackground(Color.white);
buttonPanel.setLayout(new GridLayout(0, 3));
JButton buttonBorrar = new JButton("Borrar");
buttonBorrar.setBackground(Color.white);
buttonBorrar.addActionListener(new ButtonListener());
JButton buttonOK = new JButton("OK");
buttonOK.setBackground(Color.white);
buttonOK.addActionListener(new ButtonListener());
JButton buttonCancel = new JButton("Cancel");
buttonCancel.setBackground(Color.white);
buttonCancel.addActionListener(new ButtonListener());
buttonPanel.add(buttonOK);
buttonPanel.add(buttonBorrar);
buttonPanel.add(buttonCancel);
colorPanel = new JPanel();
colorPanel.setBackground(Color.white);
colorPanel.setLayout(new GridLayout(1,2));
colorPanel.add(campanaButton);
colorPanel.add(noCampanaButton);
colorPanel.add(blueButton);
colorPanel.add(redButton);
colorPanel.add(greenButton);
colorPanel.add(yellowButton);
colorPanel.add(blackButton);

label.setBounds (insets.left, insets.top, 295, 30);
scrollPane.setBounds(insets.left, 30 + insets.top, 295, 130);
colorPanel.setBounds( insets.left, 160 + insets.top, 295,20);
esteDia.setBounds(insets.left, 200 + insets.top, 300, 20);
cadaMes.setBounds(insets.left, 220 + insets.top, 300, 20);
cadaAno.setBounds(insets.left, 240 + insets.top, 300, 20);

buttonPanel.setBounds(insets.left, 260 + insets.top, 295, 20);

add(label);
add(scrollPane);
add(colorPanel);
add(esteDia);
add(cadaMes);
add(cadaAno);
add(buttonPanel);
paintColorPanel();
}


public void resizeY(float t)
{

label.setBounds (insets.left, insets.top, 295, Integer.valueOf(Long.toString(Math.round(30*t))));
scrollPane.setBounds(insets.left, 30 + insets.top, 295, Integer.valueOf(Long.toString(Math.round(130*t))));
esteDia.setBounds(insets.left, 160 + insets.top, 300, Integer.valueOf(Long.toString(Math.round(20*t))));
cadaMes.setBounds(insets.left, 190 + insets.top, 300, Integer.valueOf(Long.toString(Math.round(20*t))));
cadaAno.setBounds(insets.left, 220 + insets.top, 300, Integer.valueOf(Long.toString(Math.round(20*t))));
buttonPanel.setBounds(insets.left, 250 + insets.top, 295, Integer.valueOf(Long.toString(Math.round(20*t))));
setSize(295, Integer.valueOf(Long.toString(Math.round(290*t))));
}


public void updateAlarm()
{

if (textArea.getText().length() > 1)
 {
Event evento = memory.getEvent(date);
if (cadaMes.isSelected())
   {
	 evento.setMonthEvent(textArea.getText());
	 evento.setMonthAlarm(alarmDate);
	}
		  
if (cadaAno.isSelected())
   {
	 evento.setYearEvent(textArea.getText());
	 evento.setYearAlarm(alarmDate);
	}

if (esteDia.isSelected())
   {
	 evento.setDayEvent(textArea.getText());
	 evento.setDayAlarm(alarmDate);
	}
		     
memory.update(evento);
 }
}




public void paintColorPanel()
{
Event evento = memory.getEvent(date);


campanaButton.setBorder(BorderFactory.createLineBorder(Color.black));
noCampanaButton.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));

if ((cadaMes.isSelected()) && (evento.getMonthAlarm() != null))
    {
	  campanaButton.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));
	  noCampanaButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 }

		  
if ((cadaAno.isSelected()) && (evento.getYearAlarm() != null))
    {
	  campanaButton.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));
	  noCampanaButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 }


if ((esteDia.isSelected()) && (evento.getDayAlarm() != null))
    {
	  campanaButton.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));
	  noCampanaButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 }
if (color == blue)
   {
	 blueButton.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));
	 redButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 greenButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 yellowButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 blackButton.setBorder(BorderFactory.createLineBorder(Color.black));
	}

if (color == red)
   {
	 redButton.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));
	 blueButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 greenButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 yellowButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 blackButton.setBorder(BorderFactory.createLineBorder(Color.black));
	}
	
if (color == green)
   {
	 greenButton.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));
	 redButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 blueButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 yellowButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 blackButton.setBorder(BorderFactory.createLineBorder(Color.black));
	}
	
if (color == yellow)
   {
	 yellowButton.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));
	 redButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 greenButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 blueButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 blackButton.setBorder(BorderFactory.createLineBorder(Color.black));
	}
	
if (color == Color.black)
   {
	 blackButton.setBorder(BorderFactory.createLineBorder(new Color(204,0,0)));
	 redButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 greenButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 yellowButton.setBorder(BorderFactory.createLineBorder(Color.black));
	 blueButton.setBorder(BorderFactory.createLineBorder(Color.black));
	}
	
colorPanel.add(campanaButton);
colorPanel.add(noCampanaButton);
add(colorPanel);
}






class ButtonListener implements ActionListener
{

public void actionPerformed (java.awt.event.ActionEvent e)
{
Event event = memory.getEvent(date);
if (e.getActionCommand() == "Cancel") 
   {
	 hide();
	}
    

if (e.getActionCommand() == "OK")
   {
	 if (textArea.getText().length() > 1)
	    {
	     Event evento = new Event(date);
		  evento.setColor(color);
	     if (cadaMes.isSelected())
		      {
				 evento.setMonthEvent(textArea.getText());
				 evento.setMonthAlarm(alarmDate);
				}
		  if (cadaAno.isSelected())
		     {
			   evento.setYearEvent(textArea.getText());
				evento.setYearAlarm(alarmDate);
				}

		  if (esteDia.isSelected())
		     {
			   evento.setDayEvent(textArea.getText());
				evento.setDayAlarm(alarmDate);	
			  }
		     
	     memory.update(evento);
		  calendario.myPanel.updateTextPane(Integer.valueOf(date.getDate()));
		  calendario.myPanel.myPanel.update(true);
		  calendario.setVisible(true);
		 }
       hide();
	 
	}

if (e.getActionCommand() == "Borrar") 
   {
	 if (cadaMes.isSelected()) memory.deleteEvent(date, "mes");
	 if (cadaAno.isSelected()) memory.deleteEvent(date, "ano");
	 if (esteDia.isSelected()) memory.deleteEvent(date, "dia");
	 calendario.myPanel.updateTextPane(Integer.valueOf(date.getDate()));
	 calendario.myPanel.myPanel.update(true);
	 calendario.setVisible(true);
	 hide();
	}

if (e.getActionCommand() == "dia")
   {
	 textArea.setText(event.getDayEvent());
	 alarmDate = event.getDayAlarm();
	 paintColorPanel();
	 repaint();
	} 
	
if (e.getActionCommand() == "mes")
   {
	 textArea.setText(event.getMonthEvent());
	 alarmDate = event.getMonthAlarm();
	 paintColorPanel();
	 repaint();
	} 
	
if (e.getActionCommand() == "ano")
   {
	 textArea.setText(event.getYearEvent());
	 alarmDate = event.getYearAlarm();
	 paintColorPanel();
	 repaint();
	} 
 
}
}

class MouseMotionHandler extends MouseInputAdapter
{
Point2D lastCurrent;


public void mouseReleased (MouseEvent e)
{
int dA = Math.round(Float.valueOf(Double.toString(e.getPoint().getX() - lastCurrent.getX())));
int dB = Math.round(Float.valueOf(Double.toString(e.getPoint().getY() - lastCurrent.getY())));

int aimLocationX = locationX + dA;
int aimLocationY = locationY + dB;
while ((locationX != aimLocationX) && (locationY != aimLocationY))
      {   
		 int da =  aimLocationX - locationX;
		 int db =  aimLocationY - locationY;
		 if (Math.abs(da) > 10)
		 locationX = locationX + Math.round(da/10);
		 if (Math.abs(db) > 10)
		 locationY = locationY + Math.round(db/10);
		 if ((Math.abs(da) <= 10) && (Math.abs(db) <= 10) ) break;
		 setLocation (locationX, locationY);
		}
 
}

public void mousePressed(MouseEvent e)
{
lastCurrent = e.getPoint();


}


}

class ColorPanelListener implements ActionListener
{
public void actionPerformed(ActionEvent e)
{
if(e.getActionCommand().equals("setAlarm"))
  { 
   choose = new ChooseFrame(mes, ano, color, date, new ChooseListener());
   choose.setSize(340, 235);
   choose.setUndecorated(true);
   choose.setLocationRelativeTo(scrollPane);
	paintColorPanel();
   choose.show();
  }
if(e.getActionCommand().equals("deleteAlarm"))
  {
  alarmDate = null;
  updateAlarm();
  paintColorPanel();
  }

if(e.getActionCommand().equals("blue"))
  {
  color = blue;
  paintColorPanel();
  }
  
if(e.getActionCommand().equals("red"))
  {
  color = red;
  paintColorPanel();
  }

if(e.getActionCommand().equals("green"))
  {
  color = green;
  paintColorPanel();
  }
  
if(e.getActionCommand().equals("yellow"))
  {
  color = yellow;
  paintColorPanel();
  }
  
if(e.getActionCommand().equals("black"))
  {
  color = Color.black;
  paintColorPanel();
  }
}


}


class ChooseListener extends MouseAdapter
{

public void mousePressed(MouseEvent e)
{
int dia = Integer.valueOf(((javax.swing.JButton)e.getComponent()).getText());
alarmDate = new fecha(dia, choose.myPanel.mes, choose.myPanel.ano);
updateAlarm();
paintColorPanel();
choose.hide();

}

}


}